﻿
using System;
using System.Windows.Forms;

/* To solve a matrix equation by the Gaussian elimination algorithm  */
/*                      www.mosismath.com                            */

namespace WindowsFormsApplication1
{

    public partial class MainWin : Form
    {
        public int MaxOrder = 4;
        public double[,] m;
        public double[] y;
        public double[] x;

        public MainWin()
        {
            int i, k;
            m = new double[MaxOrder, MaxOrder];// = new TMatrix(MaxOrder);
            x = new double[MaxOrder];
            y = new double[MaxOrder];
            DataGridViewCell cell;

            InitializeComponent();

            GMatrixA.ColumnCount = MaxOrder;
            GMatrixA.RowCount = MaxOrder;
            for (i = 0; i < GMatrixA.ColumnCount; i++)
                GMatrixA.Columns[i].Width = 160;
            GSolution.ColumnCount = 1;
            GSolution.RowCount = MaxOrder;
            GUnknowns.ColumnCount = MaxOrder;
            GUnknowns.RowCount = 1;

            // init the sample matrix equation
            m[1, 0] = 3.0;
            m[1, 1] = -5.0;
            m[1, 2] = 4.0;
            m[1, 3] = -3.0;

            y[1] = -2.5;

            m[0, 0] = 0.0;
            m[0, 1] = 0.0;
            m[0, 2] = -3.0;
            m[0, 3] = 2.0;

            y[0] = -4.1;

            m[2, 0] = 3.0;
            m[2, 1] = 2.0;
            m[2, 2] = 0.0;
            m[2, 3] = 4.0;

            y[2] = 14.8;

            m[3, 0] = 5.0;
            m[3, 1] = -2.0;
            m[3, 2] = 3.0;
            m[3, 3] = -3.0;

            y[3] = 4.0;

            for (i = 0; i < MaxOrder; i++)
            {
                for (k = 0; k < MaxOrder; k++)
                {
                    cell = GMatrixA[i, k];  // get cell to access
                    cell.Value = Convert.ToString(m[k, i]);

                }
                cell = GSolution[0, i];
                cell.Value = Convert.ToString(y[i]);
            }
        }

        private void button1_MouseClick(object sender, MouseEventArgs e)
        {
            int i, k;
            double[] buf = new double[MaxOrder];
            DataGridViewCell cell;

            for (i = 0; i < MaxOrder; i++)
            {
                for (k = 0; k < MaxOrder; k++)
                {
                    cell = GMatrixA[i, k];  // get cell to access
                    m[k, i] = Convert.ToDouble(cell.Value);
                }
                cell = GSolution[0, i];
                y[i] = Convert.ToDouble(cell.Value);
            }

            TGauss gauss;
            gauss = new TGauss(MaxOrder, m, y);
            for (i = 0; i < MaxOrder; i++)
                gauss.Pivot(i);

            if (gauss.Eliminate())
            {
                for (i = 0; i < MaxOrder; i++)
                {
                    for (k = 0; k < MaxOrder; k++)
                    {
                        cell = GMatrixA[i, k];  // get cell to access
                        cell.Value = Convert.ToString(m[k, i]);
                    }
                    cell = GSolution[0, i];
                    cell.Value = Convert.ToString(y[i]);
                }
                x = gauss.Solve();
                for (i = 0; i < MaxOrder; i++)
                {
                    cell = GUnknowns[i, 0];
                    cell.Value = Convert.ToString(Math.Round(x[i], 4));
                }
            }
            else
                MessageBox.Show("Calculation error");
        }
    }
}